//
//      DisplayPanel.java
//
//	Programmed by by Y.Motomura(motomura@etl.go.jp)
//

import java.util.*;
import java.awt.*;

class DisplayPanel extends Panel {

    final static int    maxNode=30;
    Bayonnet 	BN;
    Panel 		p1, p2[], p3[], p4[][];
    CheckboxGroup	cbGroup[];
    Checkbox		tf[][], rf[];
    Label		lb[], lf[][];
    TextField		kf[];
    int			cnt, size[];
    boolean		descrete[];

    DisplayPanel(Bayonnet manager) {
        BN = manager;
	
        setLayout(new BorderLayout());

	cnt = 0; size = new int[maxNode]; descrete = new boolean[maxNode];
	lb = new Label[maxNode]; 
	cbGroup = new CheckboxGroup[maxNode];
	p2 = new Panel[maxNode];
	p3 = new Panel[maxNode];
        p1 = new Panel();
	add("North",p1);
    }

    public void init() {
        for (Enumeration e = BN.nodes.elements(); e.hasMoreElements();) {
            addNode((Node)e.nextElement());
        }
	makePanel();
    }

    public void addNode(Node n){

	lb[cnt]= new Label(n.name);
        cbGroup[cnt] = new CheckboxGroup();
	size[cnt] = Math.abs(n.Type);
	descrete[cnt] = (n.Type > 0);
	cnt++;
	return;
    }

//
//This method should be called affter all addNode()s are completed.
//
    public void makePanel(){
	int i,j;
	int maxsize = 0;

	for(j=0; j< cnt; j++){ if(size[j]>maxsize) maxsize = size[j]; }
	rf = new Checkbox[cnt];
	kf = new TextField[cnt];
	p4 = new Panel[maxNode][maxsize];
	tf = new Checkbox[cnt][maxsize];
	lf = new Label[cnt][maxsize];
        p1.setLayout(new GridLayout(cnt,1));
	for(j=0; j< cnt; j++){
	        p2[j] = new Panel();
	        p3[j] = new Panel();
		p1.add(p2[j]);
		p2[j].setLayout(new FlowLayout(FlowLayout.LEFT));
		p3[j].setLayout(new BorderLayout());
		p2[j].add(lb[j]);
		rf[j] = new Checkbox("Estimate", cbGroup[j], true);
		Panel p5 = new Panel();
		p5.add(rf[j]);
		if(!descrete[j]){
			kf[j] = new TextField();
			p3[j].add("North",kf[j]);
		}
		p3[j].add("Center",p5);
		p2[j].add(p3[j]);
		for(i=0; i< size[j]; i++){
		        p4[j][i] = new Panel();
			p4[j][i].setLayout(new BorderLayout());
			lf[j][i] = new Label("----");
			tf[j][i] = new Checkbox(Integer.toString(i), cbGroup[j], false);
			p4[j][i].add("North",lf[j][i]);
			p4[j][i].add("Center",tf[j][i]);
			p2[j].add(p4[j][i]);
		}
	}
	repaint();
	return;
    }

    public void addNewPanel(){
	int i,j, maxsize=0;

	for(j=0; j< cnt; j++){ if(size[j]>maxsize) maxsize = size[j]; }
	rf = new Checkbox[cnt];
	kf = new TextField[cnt];
	p4 = new Panel[maxNode][maxsize];
	tf = new Checkbox[cnt][maxsize];
	lf = new Label[cnt][maxsize];
        p1.setLayout(new GridLayout(cnt,1));
//  Only for Newest Node.   
	j = cnt-1;
	        p2[j] = new Panel();
	        p3[j] = new Panel();
		p1.add(p2[j]);
		p2[j].setLayout(new FlowLayout(FlowLayout.LEFT));
		p3[j].setLayout(new BorderLayout());
		p2[j].add(lb[j]);
		rf[j] = new Checkbox("Estimate", cbGroup[j], true);
		Panel p5 = new Panel();
		p5.add(rf[j]);
		if(!descrete[j]){
			kf[j] = new TextField();
			p3[j].add("North",kf[j]);
		}
		p3[j].add("Center",p5);
		p2[j].add(p3[j]);
		for(i=0; i< size[j]; i++){
		        p4[j][i] = new Panel();
			p4[j][i].setLayout(new BorderLayout());
			lf[j][i] = new Label("----");
			tf[j][i] = new Checkbox(Integer.toString(i), cbGroup[j], false);
			p4[j][i].add("North",lf[j][i]);
			p4[j][i].add("Center",tf[j][i]);
			p2[j].add(p4[j][i]);
		}
	repaint();
	return;
    }

    public void display(int i) {
	 Node n;
	 int j;

         n = (Node) BN.nodes.elementAt(i);
 	 for(j=0; j< size[i]; j++){
	        lf[i][j].setText(Double.toString(n.outval[j]));
	 }
    }

    public void displayAll() {
	int i = 0;
        for(Enumeration e = BN.nodes.elements(); e.hasMoreElements();i++) {
            Node n = (Node)e.nextElement();
	    for(int j=0; j< n.outval.length ; j++){
	       lf[i][j].setText(Double.toString(n.outval[j]));
	    }
        }
    }

    public void setContinuousVal(int i, int j) {
	 Node n;
	 double x;

	 try{
	    x = Double.valueOf(kf[i].getText()).doubleValue();
	 }catch(NumberFormatException e){ return; }
         n = (Node) BN.nodes.elementAt(i);
	 n.putVal(j, x);
	 display(i);
    }

    public void Estimate(int j) {
	 Node n;
	 int i;

         n = (Node) BN.nodes.elementAt(j);
	 n.getVal();
	 display(j);
    }

    public boolean action(Event evt, Object arg) {
	int i, j, k;
        if (arg instanceof Boolean) {
	    for(i=0; i< cnt; i++){
		if(evt.target.equals(rf[i])){
			Estimate(i); repaint(); return(true);
		}
		for(j=0; j < size[i]; j++){
	            if(evt.target.equals(tf[i][j])) {
			if(descrete[i]){
// Descrete node case,
// Set 1.0 into clicked field.
			  ((Node)BN.nodes.elementAt(i)).putVal(j,1.0);
// Set 0.0 into unclicked field in this line.
			  for(k=0; k< size[i]; k++){
			    if(k!=j){
			  	((Node)BN.nodes.elementAt(i)).putVal(k,0.0);
			    }
			  }
			display(i);
			}else{
// Continuous node case,
// There are nothing, yet.
			setContinuousVal(i,j);
			}
		    }
		}	
            }
        }
	repaint();
        return true;
    }
}


