// TCP.java ... Listen on given PORT, make Connection, and run each services.

/* -------------------------------------------------------------------------
TCP.java ... TCP/IP interface module for server side.

	usage: new TCP(port_no, this) ... 

Listening at port_no. When requests are accepted, connections are generated.
If some connections receive input from client, call
	this.service(String input, StringBuffer output)
, then send output to client.

(All processes are done conculently thanks for Multi-Thread.)
--------------------------------------------------------------------------*/


import java.net.*;
import java.io.*;
import java.util.*;

public class TCP extends Thread {
	int Port_no;
        TCPserver service; 
	ServerSocket listen_so;

    public static void fail(Exception e, String msg){
	System.err.println(msg+":"+e); 
	System.exit(1);
    }


    TCP(int PORT_NO, TCPserver s) {
	Port_no = PORT_NO; service = s;
	try { listen_so  = new ServerSocket(Port_no); 
	} catch (Exception e) {fail(e, "Can't prepare the port");}
	this.start();
    }

    public void run(){
	try{
	   while(true){
		Socket client_so = listen_so.accept();
		connection c = new connection(client_so, service);
	   }
	}catch(IOException e){
		fail(e, "Exception while listening for Connections");
	}
    }
}

class connection extends Thread {
	protected Socket client;
	protected DataInputStream in;
	protected PrintStream out;
	TCPserver service;

	public connection(Socket client_socket, TCPserver s){
		client=client_socket; service = s;
		try{
			in = new DataInputStream(client.getInputStream());
			out = new PrintStream(client.getOutputStream());
		}
		catch(IOException e){
			try { client.close();} catch(IOException e2){};
			System.err.println("Exception while getting stream:"+e);
			return;
		}
		this.start();
	}

	public void run(){
		String input;
		StringBuffer output;
		int len;

		try{
		   output = new StringBuffer();
		   for(;;){
			input = in.readLine();
			if(input==null)break;
			output.setLength(0); // Clear old trash in the buffer.
			service.service(input,output);
			if(output.length()!=0){
			   out.println(output);
			}
		    }
		}
		catch(IOException e){; }
		finally {try {client.close();}catch(IOException e2){;}}
	}
}

// real process method service(input, output) is defined in like this.
/* 
 
	public void service(String in, StringBuffer out){
		int i;
		StringTokenizer st;
		String word;

		st = new StringTokenizer(in);
		if(st.hasMoreTokens()!=true) return;
		word = new String(st.nextToken());
		if("set".equals(word)){ 
		    for(i=0; (i<node.outval.length)&&(st.hasMoreTokens()); i++){
			node.outval[i]=new Double(st.nextToken("( ),\n\t\r")).doubleValue();
		    }
		}else{
  		  if("get".equals(word)){ 
		    if(st.hasMoreTokens()){ 
			word = new String(st.nextToken()); 
		    	if("backword".equals(word)){
				node.getVal2();
		    	}else{
		    	     if("forword".equals(word)){
			    	node.getVal();
		    	     }
			}
		    }
		    out.append("( ");
		    for(i=0; i<node.outval.length; i++){
			out.append(Double.toString(node.outval[i]));
			out.append(" ");
		    }
		    out.append(")");
		  }
		}
	}
*/



